//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "box.h"
#include "repere.h"
#include "main.h"
#include "iboolean.h"
#include <ComCtrls.hpp>

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// Composants grs par l'EDI
        TImage *Image1;
        TImage *Image_wordhat;
        TImage *Image_trueword;
        TTrackBar *TrackBar1;
        TMemo *Memo1;
        TImage *Image2;
        TButton *Button1;
        TImage *Image_fs;
        TImage *Image_cond;
        TImage *Image_fr;
        TImage *Image_a;
        TImage *Image_psi;
        TImage *Image_deltas;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TLabel *Label7;
        TLabel *Label8;
        TButton *Button2;
        TButton *Button3;
        void __fastcall TrackBar1Change(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall Button3Click(TObject *Sender);
private:	// Dclarations utilisateur
public:		// Dclarations utilisateur
        __fastcall TForm1(TComponent* Owner);
        void readdata();
//        bool TForm1::Contract(box& P);
//        box TForm1::SIVIA();
        void TForm1::GO(double amin,double amax,double phimin,double phimax);
        void TForm1::Contract(box& Z, interval Xk,interval Yk,interval Thetak,
                           interval dXk,interval dYk,interval dThetak,
                           interval ddXk,interval ddYk,interval ddThetak,
                           interval U1k,interval U2k);
        void TForm1::SIVIA(box& Z0);
        void TForm1::Draw_wind(repere& R,double x,double y,double psi,double a, TColor col,int taille);
        void TForm1::Draw_sailboat(repere& R,double x,double y,double theta,double deltag,
                           double deltav, double cond);
        void TForm1::Solve();




        repere R1,R2,R_trueword,R_wordhat,R_fs,R_fr,R_a,R_psi,R_cond,R_deltas;
        int k,kmax;
        double amin,amax,psimin,psimax,tmax;
        double p1,p2,p3,p4,p5,p6,p7,p8,p9,p10;
        double e_u,e_xy,e_theta, e_dxy, e_dtheta, e_ddxy, e_ddtheta;
        vector <double> t,u1,u2,cond,deltas,x,y,theta,v,dx,dy,dtheta,dv,ddx,ddy,ddtheta,fr,fs,a,psi;
        vector <interval> U1,U2,X,Y,Theta,dX,dY,dTheta,ddX,ddY,ddTheta;

};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
